Attribute VB_Name = "Registry"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

 
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
        Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal _
        lpSubKey As String, ByVal ulOptions As Long, ByVal _
        samDesired As Long, phkResult As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
        Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal lpReserved As Long, _
        lpType As Long, lpData As Any, lpcbData As Any) As Long

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" _
        Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal _
        lpSubKey As String, ByVal Reserved As Long, ByVal _
        lpClass As String, ByVal dwOptions As Long, ByVal _
        samDesired As Long, ByVal lpSecurityAttributes As Any, _
        phkResult As Long, lpdwDisposition As Long) As Long

Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal _
        hKey As Long) As Long

Private Declare Function RegSetValueEx Lib "advapi32.dll" _
        Alias "RegSetValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal Reserved As Long, ByVal _
        dwType As Long, lpData As Long, ByVal cbData As Long) _
        As Long

Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" _
        Alias "RegSetValueExA" (ByVal hKey As Long, ByVal _
        lpValueName As String, ByVal Reserved As Long, ByVal _
        dwType As Long, ByVal lpData As String, ByVal cbData As _
        Long) As Long

Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias _
        "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As _
        String) As Long

Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias _
        "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName _
        As String) As Long

Public Enum HKEY_ROOTS
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
 
Const KEY_READ = KEY_QUERY_VALUE Or _
                 KEY_ENUMERATE_SUB_KEYS _
                 Or KEY_NOTIFY
                  
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or _
                       KEY_SET_VALUE Or _
                       KEY_CREATE_SUB_KEY Or _
                       KEY_ENUMERATE_SUB_KEYS Or _
                       KEY_NOTIFY Or _
                       KEY_CREATE_LINK
Const ERROR_SUCCESS = 0&

Const REG_NONE = 0
Const REG_SZ = 1
Const REG_EXPAND_SZ = 2
Const REG_BINARY = 3
Const REG_DWORD = 4
Const REG_DWORD_LITTLE_ENDIAN = 4
Const REG_DWORD_BIG_ENDIAN = 5
Const REG_LINK = 6
Const REG_MULTI_SZ = 7

Const REG_OPTION_NON_VOLATILE = &H0

Private RegRoot As Long

Public Function RegKeyExist(Root As HKEY_ROOTS, Key$) As Long
     Dim Result As Long, hKey As Long
   
     'Prfen ob ein Schlssel existiert
     Result = RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey)
     If Result = ERROR_SUCCESS Then Call RegCloseKey(hKey)
     RegKeyExist = Result
End Function

Public Function RegKeyCreate(Root As HKEY_ROOTS, Newkey$) As Long
    Dim Result As Long, hKey As Long, Back As Long
    
    'Neuen Schlssel erstellen
    Result = RegCreateKeyEx(Root, Newkey, 0, vbNullString, _
                             REG_OPTION_NON_VOLATILE, _
                             KEY_ALL_ACCESS, 0&, hKey, Back)
    
    If Result = ERROR_SUCCESS Then
        Result = RegFlushKey(hKey)
        If Result = ERROR_SUCCESS Then Call RegCloseKey(hKey)
        RegKeyCreate = Back
    End If
End Function

Public Function RegKeyDelete(Root As HKEY_ROOTS, Key$) As Long
   'Schlssel erstellen
   RegKeyDelete = RegDeleteKey(Root, Key)
End Function

Public Function RegFieldDelete(Root As HKEY_ROOTS, Key$, Field$) As Long
    Dim Result As Long, hKey As Long
    
    'Feld lschen
    Result = RegOpenKeyEx(Root, Key, 0, KEY_ALL_ACCESS, hKey)
    If Result = ERROR_SUCCESS Then
        Result = RegDeleteValue(hKey, Field)
        Result = RegCloseKey(hKey)
    End If
    RegFieldDelete = Result
End Function

Public Function RegValueSet(Root As HKEY_ROOTS, Key$, Field$, Value As Variant, _
                            Optional ReplaceVBCrLf As Boolean = True, _
                            Optional Create As Boolean = True) As Long

    Dim Result As Long, hKey As Long, s As String
    Dim l As Long, FoundNullChars As Boolean

    'Wenn der Key nicht existiert, dann erstellen
    If Not RegKeyExist(Root, Key) And Create = True Then
        RegKeyCreate Root, Key
    End If

    If InStr(1, Value, vbCrLf) And ReplaceVBCrLf Then
        Value = Replace(Value, vbCrLf, vbNullChar)
        FoundNullChars = True
    End If

    'Wert in ein Feld der Registry schreiben
    Result = RegOpenKeyEx(Root, Key, 0, KEY_ALL_ACCESS, hKey)
    If Result = ERROR_SUCCESS Then
        Select Case VarType(Value)
        Case vbInteger, vbLong
            l = CLng(Value)
            Result = RegSetValueEx(hKey, Field, 0, REG_DWORD, l, 4)
        Case vbString
            If FoundNullChars Then
                s = CStr(Value)
                Result = RegSetValueEx_Str(hKey, Field, 0, REG_MULTI_SZ, s, _
                                         Len(s))
            Else
                s = CStr(Value)
                Result = RegSetValueEx_Str(hKey, Field, 0, REG_SZ, s, _
                                         Len(s))
            End If
       End Select
       
       Result = RegCloseKey(hKey)
     End If

     RegValueSet = Result
 End Function

 Public Function RegValueGet(Root As HKEY_ROOTS, Key$, Field$, Value As Variant) As Long
    Dim Result As Long, hKey As Long, dwType As Long
    Dim Lng As Long, Buffer As String, l As Long
   
    'Wert aus einem Feld der Registry auslesen
    Result = RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey)
    If Result = ERROR_SUCCESS Then
        Result = RegQueryValueEx(hKey, Field, 0&, dwType, ByVal 0&, l)
        If Result = ERROR_SUCCESS Then
            Select Case dwType
                Case REG_SZ
                    Buffer = Space$(l)
                    Result = RegQueryValueEx(hKey, Field, 0&, _
                             dwType, ByVal Buffer, l)
                    
                    If Result = ERROR_SUCCESS Then Value = Buffer
                    
                Case REG_DWORD
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, Lng, l)
                    If Result = ERROR_SUCCESS Then Value = Lng
                
                Case REG_MULTI_SZ
                    Buffer = Space$(l)
                    Result = RegQueryValueEx(hKey, Field, 0&, _
                             dwType, ByVal Buffer, l)
                    
                    Buffer = Replace(Buffer, vbNullChar, vbCrLf)
             
                    If Result = ERROR_SUCCESS Then Value = Buffer
            End Select
        End If
    End If

    If Result = ERROR_SUCCESS Then Result = RegCloseKey(hKey)
    RegValueGet = Result
End Function



